using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Web;
using System.Web.Services;
using System.Xml;
using System.Web.Services.Protocols;

namespace XMLGatewayService
{
	/// <summary>
	/// XML Gateway Web Sevices.
	/// </summary>
	
	// Define a SOAP header by deriving from the SoapHeader base class.
	public class Authenticator : SoapHeader 
	{
		public string Username;
		public string Password;
	}



	[WebService(Namespace="http://www.xmlgateway.co.uk", Name="XML Gateway Online Booking", Description="XML Gateway Bookings Services")]
	public class Schedules : System.Web.Services.WebService
	{
		// Define a SOAP header by deriving from the SoapHeader base class.
		public Authenticator authorise ;
		public Authenticator tempAuthorise;

		public Schedules()
		{
			//CODEGEN: This call is required by the ASP.NET Web Services Designer
			InitializeComponent();
			//tempAuthorise = new Authenticator();
			//tempAuthorise.Username="Admin";
			//tempAuthorise.Password="Password";
		}

		#region Component Designer generated code
		
		//Required by the Web Services Designer 
		private IContainer components = null;
				
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if(disposing && components != null)
			{
				components.Dispose();
			}
			base.Dispose(disposing);		
		}
		
		#endregion

		
		[WebMethod]
		public DataSet GetSchedule(string Location)
		{	
			//Build SQL Statement
			string SQL = "Select * from Schedule Where Location like '" + Location + "'";
			//Returns the physical to the Courses.MDB
			string strDBPath = Server.MapPath("Courses.MDB");
			//Build connection string
			string strConnectionString = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + strDBPath;
			//Create a Connection object
			System.Data.OleDb.OleDbConnection conCourses = new System.Data.OleDb.OleDbConnection();
			//Create a Data Adapter object
			System.Data.OleDb.OleDbDataAdapter adpSchedules = new System.Data.OleDb.OleDbDataAdapter(SQL,conCourses);
			//Create a Dataset object
			System.Data.DataSet dsSchedules = new System.Data.DataSet();
			try
			{	
				//Establish a connection
				conCourses.ConnectionString=strConnectionString;
				conCourses.Open();
				
				//Fill a Datase
				dsSchedules.DataSetName="Schedules";
				adpSchedules.Fill(dsSchedules,"Schedule");
				return dsSchedules;				
			}
			catch (System.Exception exp)
			{
				throw(exp);
			}
			finally
			{
				conCourses.Close();
			}
		}
		[WebMethod]
		//Establich security
		[SoapHeader("authorise", Direction=SoapHeaderDirection.In,Required=true)]
		public DataSet GetBooking(long CustomerID)
		{	
			//Build an SQL Statement
			string SQL;
			SQL = "Select Bookings.BookingID,Bookings.DelegatesNbr,Bookings.TotalPrice,Customers.Name,Schedule.Duration,Schedule.Location,Schedule.StartDate ";
			SQL = SQL + "From Bookings,Customers,Schedule Where Customers.CustomerID = Bookings.CustomerID And Schedule.ScheduleID = Bookings.ScheduleID ";
			SQL = SQL + "and  Bookings.CustomerID = " + CustomerID;
			
			//Returns the physical to the Courses.MDB
			string strDBPath = Server.MapPath("Courses.MDB");
			//Build connection string
			string strConnectionString = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + strDBPath;			System.Data.OleDb.OleDbConnection conCourses = new System.Data.OleDb.OleDbConnection();
			
			//Create a Data Adapter object
			System.Data.OleDb.OleDbDataAdapter adpSchedules = new System.Data.OleDb.OleDbDataAdapter(SQL,conCourses);
			//Create a Dataset object
			System.Data.DataSet dsBookings = new System.Data.DataSet();
			try
			{
				//Authenticate user: This normally would connect to a database 
				//and check the user identity
				if (authorise.Username != "Admin")
				{
					//Throw the exception    
					throw new SoapHeaderException("<error message>invalid user name: Hint it starts with A and finishes with n has five letters e.g. Admin<'error message> ",SoapException.ClientFaultCode);
				}
				if (authorise.Password != "Password")
				{
					//Throw the exception    
					throw new SoapHeaderException("<error message>invalid password: Hint it starts with P and finishes with d and has 8 letters e.g. Password</error message>",SoapException.ClientFaultCode);
				}

				
				if (authorise.Username == "Admin" && authorise.Password == "Password")
				{
					//If user is authenticated then return data
					conCourses.ConnectionString=strConnectionString;
					conCourses.Open();
				
					dsBookings.DataSetName="Bookings";
					adpSchedules.Fill(dsBookings,"Booking");
					return dsBookings;
				}
				else
				{
					//Throw the exception    
					throw new SoapHeaderException("invalid user",SoapException.ClientFaultCode);     

				}
								
			}
			catch (System.Exception exp)
			{
				 throw(exp);
			}
			finally
			{
				conCourses.Close();
			}
		}

	}
}
